#property indicator_separate_window //  
#property indicator_buffers 3
//-- 
extern double period=0.5; // . (<1)   (>1) EMA
extern int History=9999; // -  ; 0 - 
//--
double MAc[],MAh[],MAl[]; //  

double k; // . EMA

string NAME[]; //    
int NameCount; //   
string ShortName; //      
string _ID; //  ()  

//=============================================================
int init()
  {
   SetIndexBuffer(0,MAc); //   EMA  Close   Close
   SetIndexStyle(0,DRAW_NONE);
   SetIndexLabel(0,NULL);

   SetIndexBuffer(1,MAh); //   EMA  Close   High
   SetIndexStyle(1,DRAW_NONE);
   SetIndexLabel(1,NULL);

   SetIndexBuffer(2,MAl); //   EMA  Close   Low
   SetIndexStyle(2,DRAW_NONE);
   SetIndexLabel(2,NULL);

//----
   _ID=GetID(); //   ()  

   ShortName="Example";
   IndicatorShortName(ShortName); //     

   if(period>1) k=2/(period+1); //   >1,     EMA
   else k=period; // <=1 -  

   return(0);
  }

//=============================================================
int start()
  {
   
   static bool NotFirst; //    ; =0     
   bool NewBar; //  1-   ; =1 -   
   static int BarsOld;
   
   if(BarsOld!=Bars) {BarsOld=Bars; NewBar=1;} //  -   -   

   int IC=IndicatorCounted();
   if(NotFirst && IC==0) {deinit(); xInit();} //  IndicatorCounted=0     - 
   NotFirst=1; //   "  "
   int limit=Bars-IC-1;
   if(History!=0 && limit>History) limit=History-1;

   for(int i=limit; i>=0; i--)
     {   
      MAc[i]=k*Close[i]+(1-k)*MAc[i+1]; // EMA  Close   Close
      MAh[i]=k*High[i] +(1-k)*MAc[i+1]; // EMA  Close   High
      MAl[i]=k*Low[i]  +(1-k)*MAc[i+1]; // EMA  Close   Low
   
      if(NewBar) //  1-   , 
        {
         int win=GetWinNumber(); //     
   //  
         static string _mac,_mah,_mal; //  
         datetime t0=Time[i];
         datetime t1=Time[i+1];
         datetime xt1=xTime(i-1);
         _mac=Name(); // EMA  Close   Close
         ObjectCreate(_mac,OBJ_TREND,win,t0,MAc[i],xt1,MAc[i]); // EMA  Close
         ObjectSet(_mac,OBJPROP_COLOR,Blue);
         ObjectSet(_mac,OBJPROP_RAY,0);

         _mah=Name(); // EMA  Close   High
         ObjectCreate(_mah,OBJ_TREND,win,t0,MAc[i],t0,MAh[i]);
         ObjectSet(_mah,OBJPROP_COLOR,Red);
         ObjectSet(_mah,OBJPROP_RAY,0);

         _mal=Name();  // EMA  Close   Low
         ObjectCreate(_mal,OBJ_TREND,win,t0,MAc[i],t0,MAl[i]);
         ObjectSet(_mal,OBJPROP_COLOR,Green);
         ObjectSet(_mal,OBJPROP_RAY,0);
        }
      else //  
        {
         ObjectSet(_mac,OBJPROP_PRICE1,MAc[i]);
         ObjectSet(_mac,OBJPROP_PRICE2,MAc[i]);
      
         ObjectSet(_mah,OBJPROP_PRICE1,MAc[i]);
         ObjectSet(_mah,OBJPROP_PRICE2,MAh[i]);
      
         ObjectSet(_mal,OBJPROP_PRICE1,MAc[i]);
         ObjectSet(_mal,OBJPROP_PRICE2,MAl[i]);
        }
     }
   
   return(0);
  }
//=============================================================

//   ()  
string GetID()
  {
   string _GV="__DrawExample"; //     
   int ID=GlobalVariableGet(_GV); //    ()  
   ID++; //  
   GlobalVariableSet(_GV,ID); //    .; ( .. ,  ) 
   
   return(DoubleToStr(ID,0)); //   ()  
  }

//     
int GetWinNumber()
  {
   IndicatorShortName(_ID); // :   =  ()  
   int win=WindowFind(_ID); //       ()  
   IndicatorShortName(ShortName); //   

   return(win); //   
  }
  
//    .       
string Name() 
  {
   NameCount++; //  . 
   string _Name=ShortName+" | "+_ID+" | "+NameCount; //   = . +    +  .
   ArrayResize(NAME,NameCount); //   .   1
   NAME[NameCount-1]=_Name; //     

   return(_Name); //    
  }

//    
datetime xTime(int i)
  {
   if(i<0) return(Time[0]-i*Period()*60);
   return(Time[i]);
  }

// -  
void xInit()
  {
   ArrayInitialize(MAc,0.0);
   ArrayInitialize(MAh,0.0);
   ArrayInitialize(MAl,0.0);
   return;
  }
  
int deinit()
  {
   for(int i=0; i<NameCount; i++) ObjectDelete(NAME[i]); //    
   ArrayResize(NAME,1); NameCount=0; //    
   return(0);
  }
  